# -*- coding: utf-8 -*-
"""TODO3.ipynb

Automatically generated by Colaboratory.

Original file is located at
    https://colab.research.google.com/drive/1oFfLUT2zuaiq50Im22gZG1U4N5CxkOiI
"""

import pandas as pd
df = pd.read_csv('goodreads.csv')
df.dtypes

df = pd.read_csv('goodreads.csv', names = ['rating','review_count','isbn', 'booktype', 'author_url', 'year', 'genre_urls', 'dir', 'rating_count', 'name'])
df.dtypes

df.isna().sum()

df[df.year.isna() == True]

df.shape

df.dropna(subset = ['year', 'rating'], inplace = True)
df.shape

df.dtypes

dfReviewCount = df.review_count.astype('int')
dfReviewCount.dtypes

dfYear = df.year.astype('int')
dfYear.dtypes

df.dtypes

askQuestion = pd.read_csv('goodreads.csv', names = ['rating','review_count','isbn', 'booktype', 'author_url', 'year', 'genre_urls', 'dir', 'rating_count', 'name'])
askQuestion

askQuestion.isna().sum()

genreDf = askQuestion.dropna(subset = ['genre_urls'])
genreDf.shape

genre = askQuestion.genre_urls[0]
genre

newGenre = genre.split('/genres/')[1:]
newGenre

newGenre2 = []
for i in newGenre:
  newGenre2.append(i.replace("|"," "))

newGenre2

# def get_genre(newGenre):
#   genre = newGenre.replace("|","") for genre in newGenr
#   return genre

# askQuestion['genre'] = askQuestion.genre_urls.map(get_genre)
# askQuestion.head()

rating = df[['name', 'rating']]
rating

rating['rating'].max()

rating.agg({"rating":'max','rating':'mean'})

url = df.author_url[0]
url

url.split(".")[-1]

def get_author(url):
  author = url.split(".")[-1]
  return author

df['author'] = df.author_url.map(get_author)
df.head()

newDf = df[['rating', 'author', 'name']]
newDf
len(newDf.groupby('author'))
rate = newDf.groupby('author')
rate.get_group('A_A_Milne').shape
for key, valuedf in rate:
  highly_rated = valuedf[valuedf['rating'] == valuedf.rating.max()]
  print(highly_rated.author, highly_rated.rating)

newDf = df[['author', 'rating']]
# newDf.sort_values(by = ['rating'], ascending = False, inplace = True)
newDf